/* #define DEBUGma          /* print function name */
/* #define DEBUGstatus      /* print  intrno,vector */

#include<sys/ioccom.h>  /* for _IORW in ioctl routine */
#include<sys/param.h>
#include<sys/buf.h>
#include<sys/file.h>
#include<sys/dir.h>
#include<sys/user.h>
#include<sys/uio.h>
#include<machine/psl.h>
#include<sundev/mbvar.h>
#include<string.h>
#include<sbusdev/vme.h>
#include<sbusdev/vmelib.h>
#include<sys/errno.h>

int int_flag[NUMBER_OF_VECTOR];     /* By what sleep() was wokenup           */
int int_vectorno[NUMBER_OF_VECTOR];   /* vector installed, set vector number   */
int int_count[NUMBER_OF_VECTOR];    /* How many Interrupt while int enable   */
int int_enable[NUMBER_OF_VECTOR];   /* enable or disable                     */
int int_channel[NUMBER_OF_VECTOR];  /*semaphore for sleep/wakeup.only define */
int timeoutkey[NUMBER_OF_VECTOR];   /*  use only for timeout/untimeout       */

int intopen(), intclose(), intmmap(),intintr();
int intread(),intwrite(),intprobe();

int inttimeout();
int sparc_int_enable();

struct mb_device *intdinfo[NINT];
struct mb_driver intdriver={intprobe,0,0,0,0,0,
			      1,"int",intdinfo,0,0,0,0};

intprobe(){return 1;}
intread() {return 0;}
intwrite(){return 0;}

intopen( dev, flags )
int flags;
{
#ifdef DEBUGma
  printf("Debug : intopen \n");
#endif
  return 0;
}

intclose( dev, flags )
int flags; 
{
#ifdef DEBUGma
  printf("Debug : intclose \n");
#endif
  return 0;
}

intmmap( dev, off, prot )
int prot; 
{
#ifdef DEBUGma
  printf("Debug : intmmap \n");
#endif
  return 0;
}

intioctl(dev, cmd, data_pointer, flag)
     dev_t dev;
     int cmd;
     int *data_pointer;
     int flag; 
{
  struct intcmd *intcmd;
  int number,data,reply1,reply2;
  int vector,intrno,timelimit;
  int i;  /*for  INT_INIT */
  intcmd = (struct intcmd *)data_pointer;    /* received by (struct intcmd) */
  data=intcmd->data;

  switch(cmd){
  case INT_INIT:
#ifdef DEBUGma
    printf("Debug : intioctl :INT_INIT\n");
#endif 
    int_flag[0]=MA_INTERRUPT;

    for(i=0;i<NUMBER_OF_VECTOR;i++){int_flag[i]  = MA_INTERRUPT;}
    for(i=0;i<NUMBER_OF_VECTOR;i++)int_enable[i]= MA_INTDISABLE;
    for(i=0;i<NUMBER_OF_VECTOR;i++)int_count[i] = 0;
    for(i=0;i<NUMBER_OF_VECTOR;i++){int_vectorno[i] = MA_notINSTALL;}

    break;
  case INT_OPEN:

#ifdef DEBUGma
    printf("Debug : intioctl :INT_OPEN\n");
#endif
    vector=intcmd->number;
    if(vector<INT_MIN_VECTOR || vector>INT_MAX_VECTOR)return EINVAL;
    intrno=vector-INT_MIN_VECTOR;

    int_vectorno[intrno]=vector;
    int_enable[intrno]=MA_INTDISABLE;
    int_flag[intrno]=MA_INTERRUPT;
    int_count[intrno]=0;
    intcmd->reply1=intrno; 

    break;



  case INT_CLOSE:
    intrno=intcmd->number;

#ifdef DEBUGma
    printf("Dubug : intioctl :INT_CLOSE \n");
#endif    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL;

    int_vectorno[intrno]=MA_notINSTALL;

    break;



  case INT_ENABLE:

#ifdef DEBUGma
    printf("Debug : intioctl :INT_ENABLE\n");
#endif
    intrno=intcmd->number;
    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL ;
    if(int_vectorno[intrno]==MA_notINSTALL)return ENODEV;

    int_enable[intrno]=MA_INTENABLE;
    int_flag[intrno]=MA_INTERRUPT;

    break;



  case INT_DISABLE:
    intrno=intcmd->number;

#ifdef DEBUGma
    printf("Dubug : intioctl :INT_DISABLE \n");
#endif
    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL;
    if(int_vectorno[intrno]==MA_notINSTALL)return ENODEV;

    int_enable[intrno]=MA_INTDISABLE;
    int_flag[intrno]=MA_INTERRUPT;


    break;



  case INT_WAIT:
    intrno=intcmd->number;

#ifdef DEBUGma
    printf("Dubug : intioctl :INT_WAIT \n");
#endif    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL;
    if(int_vectorno[intrno]==MA_notINSTALL)return ENODEV;
    if(int_enable[intrno]==MA_INTDISABLE)return ENODEV;

    timeoutkey[intrno]=intrno;
    timelimit=data;
    if(data<0)timelimit=INT_default_TIMEOUT;

    if(int_flag[intrno]==MA_WAITING){
      untimeout(inttimeout,&timeoutkey[vector]);
      reply1=int_count[intrno];
      intcmd->reply1=reply1;
      intcmd->reply2=MA_SIGNAL_STOP;
      int_count[intrno]=0;
      int_flag[intrno]=MA_INTERRUPT;
      return EINTR;
    }
    if(int_count[intrno]==0){
      int_flag[intrno]=MA_WAITING;
      timeout(inttimeout,&timeoutkey[intrno],timelimit*100);  
      sleep(&int_channel[intrno],INTPRI);        /* sosite sugu neru */
    }
    reply1=int_count[intrno];
    intcmd->reply1=reply1;
    reply2=int_flag[intrno];
    intcmd->reply2=reply2;
    int_count[intrno]=0;

    if(int_flag[intrno]==MA_TIMEOUT){
      int_flag[intrno]=MA_INTERRUPT;
      return ETIMEDOUT;
      
    }
    int_flag[intrno]=MA_INTERRUPT;
    break;



  case INT_NOWAIT:
    intrno=intcmd->number;

#ifdef DEBUGma
    printf("Dubug : intioctl :INT_NOWAIT \n");
#endif
    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL;
    if(int_vectorno[intrno]==MA_notINSTALL)return ENODEV;
    if(int_enable[intrno]==MA_INTDISABLE)return ENODEV;
    
/*    strncpy(&(intcmd->reply1),&(int_count[intrno]),2);
    strncpy(&(intcmd->reply2),&(int_flag[intrno]),2); */
    reply1=int_count[intrno];
    intcmd->reply1=reply1;
    reply2=int_flag[intrno];
    intcmd->reply2=reply2;
    int_count[intrno]=0;
    int_flag[intrno]=MA_INTERRUPT;


    break;



  case INT_CLEAR:
    intrno=intcmd->number;

#ifdef DEBUGma
    printf("Dubug : intioctl :INT_CLEAR \n");
#endif
    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL;
    if(int_vectorno[intrno]==MA_notINSTALL)return ENODEV;
    if(int_enable[intrno]==MA_INTDISABLE)return ENODEV;

    int_count[intrno]=0;
    int_flag[intrno]=MA_INTERRUPT;

    break;



  case INT_CHECK:
    intrno=intcmd->number;

#ifdef DEBUGma
    printf("Dubug : intioctl :INT_CHECK \n");
#endif
    
    if(intrno<INT_INTR0 || intrno>INT_INTR9)return EINVAL;
    if(int_vectorno[intrno]==MA_notINSTALL)return ENODEV;
    if(int_enable[intrno]==MA_INTDISABLE)return ENODEV;


/*    strncpy(&(intcmd->reply1),&(int_count[intrno]),2);
    strncpy(&(intcmd->reply2),&(int_flag[intrno]),2);*/
    reply1=int_count[intrno];
    intcmd->reply1=reply1;
    reply2=int_flag[intrno];
    intcmd->reply2=reply2;

    break;
  }
  return 0;
}

inttimeout(intrno)
caddr_t intrno;
{
#ifdef DEBUGstatus
  printf("Debug : inttimeout  intrno=0x%x\n",*(int *)intrno);
#endif
  int_flag[*(int *)intrno]=MA_TIMEOUT;                /* time over de okita */
  wakeup(&int_channel[*(int *)intrno]);
}

int int_intr(vector)         /*  called by intintr[a-j]  */
int vector;
{
  int intrno;
  intrno=vector-INT_MIN_VECTOR;
#ifdef DEBUGstatus
  printf("Debug : int_intr  vector=0x%x \n",vector);
#endif
  if(int_vectorno[intrno]!=MA_notINSTALL &&    /* for nomal situation */
     int_enable[intrno]==MA_INTENABLE &&
     int_flag[intrno]!=MA_INTERRUPT){
    int_count[intrno]++;
    timeoutkey[intrno]=intrno;
    untimeout(inttimeout,&timeoutkey[intrno]);
    wakeup(&int_channel[intrno]);
  }
  if(int_vectorno[intrno]!=MA_notINSTALL &&    /* not wait but count  */
     int_enable[intrno]==MA_INTENABLE &&
     int_flag[intrno]==MA_INTERRUPT){
    int_count[intrno]++;
  }

 /* sparc_int_enable();  */
}

intintra( unit )
int unit; {int_intr(0xF0);}

intintrb( unit )
int unit; {int_intr(0xF1);}

intintrc( unit )
int unit; {int_intr(0xF2);}

intintrd( unit )
int unit; {int_intr(0xF3);}

intintre( unit )
int unit; {int_intr(0xF4);}

intintrf( unit )
int unit; {int_intr(0xF5);}

intintrg( unit )
int unit; {int_intr(0xF6);}

intintrh( unit )
int unit; {int_intr(0xF7);}

intintri( unit )
int unit; {int_intr(0xF8);}

intintrj( unit )
int unit; {int_intr(0xF9);}


/* -------------------- INTENABLE_REG ------------------------*/

sparc_int_enable()
{
  struct vme_ioctl vme_ioctl;
  int fd;

  fd=open("/dev/vme32d32",O_RDWR);
  if(fd==-1){
    printf("Error(int.c) :can't open /dev/vme32d32 \n");
    return -1;
   }
  vme_ioctl.reg_no = INTENABLE_REG;
  
  if ((ioctl(fd, VME_GET_REG, &vme_ioctl)) == -1) {
    printf("Error(int.c) :ioctl VME_GET_REG failed \n");
  }
  vme_ioctl.reg_data &= 0x01;
  vme_ioctl.reg_data |= 0x7e;	/* enable all interrupts */  
  if ((ioctl(fd, VME_SET_REG, &vme_ioctl)) == -1) {
    printf("Error(int.c) :ioctl VME_SET_REG failed \n");
  }
#ifdef DEBUGma
  printf("Debug :all interrupt eneble \n");
#endif
}


