/* File name     : force_memtest.c
 * Creation date : May 1993
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

#include <stdio.h>
#include <sys/file.h>
#include<sys/types.h>
#include<shmmap.h>
#include<sys/time.h> 
#include "vmelib.h"
#define MEM_A32 0x11000000
#define MEM_ADDR MEM_A32
#define MEM_MODE VME_A32D32MODE
#define MEM_SIZE 0x200000
#define MEM_SIZE_CHAR MEM_SIZE
#define MEM_SIZE_SHORT MEM_SIZE/2
#define MEM_SIZE_LONG MEM_SIZE/4
#define LOOP 10
extern int errno;

static char buf[MEM_SIZE], bufw[MEM_SIZE];
static char *mm;
static long  buf_l[MEM_SIZE_LONG], bufw_l[MEM_SIZE_LONG];
static volatile long *mm_long;

main()
{
    int i, j;
    long *buf_long = buf_l;
    volatile caddr_t vme_addr;
    struct timeval tp1,tp2;
    struct timezone tzp;

    bufw[0] = 'a';
    for(i=1;i<MEM_SIZE;i++) bufw[i] = (char)((int)bufw[i-1]+ 1);
    buf_long[0] = 0xaaaaaaaa;
    for(i=1;i<MEM_SIZE_LONG;i++) bufw_l[i] = bufw_l[i-1] + 1;
    vme_addr = (volatile caddr_t)vme_mapopen(MEM_MODE, MEM_ADDR,
                                             MEM_SIZE);
    if (vme_addr == ( volatile caddr_t)-1) {
        printf("mp1 cannot open! \n");
        exit(1);
    }

    mm = (volatile char *)vme_addr;
    mm_long = (volatile long *)vme_addr;

    printf("address = %x\n", mm_long);
/*
    printf("strncpy : from host to VME\n");
    gettimeofday(&tp1,&tzp);
    for( i = 0; i < LOOP; i++)
        strncpy(mm, bufw, MEM_SIZE);
    gettimeofday(&tp2,&tzp);
    print_data(&tp1, &tp2);

    printf("strncpy : from VME to host\n");
    gettimeofday(&tp1,&tzp);
    for( i = 0; i < LOOP; i++)
        strncpy(buf, mm, MEM_SIZE);
    gettimeofday(&tp2,&tzp);
    print_data(&tp1, &tp2);
*/

    printf("memcpy : from host to VME\n");
    gettimeofday(&tp1,&tzp);
    for( i = 0; i<LOOP; i++)
        memcpy(mm,bufw,MEM_SIZE);
    gettimeofday(&tp2,&tzp);
    print_data(&tp1, &tp2);

    printf("memcpy : from VME to host\n");
    gettimeofday(&tp1,&tzp);
    for( i = 0; i<LOOP; i++)
        memcpy(buf,mm,MEM_SIZE) ;
    gettimeofday(&tp2,&tzp);
    print_data(&tp1, &tp2);

    printf("doloop : from host to VME\n");
    gettimeofday(&tp1,&tzp);
    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_LONG; j++)
            mm_long[j] = (volatile long)bufw_l[j];
    gettimeofday(&tp2,&tzp);
    print_data(&tp1, &tp2);

    printf("doloop : from VME to host\n");
    gettimeofday(&tp1,&tzp);
    for( i = 0; i<LOOP; i++)
        for( j = 0; j<MEM_SIZE_LONG; j++)
            buf_l[j] = (long)mm_long[j];
    gettimeofday(&tp2,&tzp);
    print_data(&tp1, &tp2);
    for(i = 0; i < MEM_SIZE_LONG; i++)
        if( buf_l[i] != bufw_l[i] ) {
	    printf("error at location %d\n", i);
	    printf("written data = %x  read data = %x\n", bufw_l[i], buf_l[i]);
	    exit(1);
	}
}

print_data(tp1, tp2)
struct timeval *tp1,*tp2; {
    int sec;
    float usec, fsec;

    sec = tp2->tv_sec - tp1->tv_sec;
    usec = (float)(tp2->tv_usec) - (float)(tp1->tv_usec);
    printf("sec = %f usec/1000000.= %f\n", (float)(sec), usec/1000000.);
    fsec = (float)(sec) + usec/1000000.;
    printf("Total %f sec for %d bytes transfer\n",fsec,MEM_SIZE*LOOP);
    printf("speed of data transfer : %3.3f MB/sec\n",
	   ((float)(MEM_SIZE*LOOP))/1000000./fsec);

}
