/* File name     : maptest.c
 * Creation date : August 1994
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

#include	<stdio.h>
#include	<sys/types.h>
#include        "vmelib.h"
#include        "intreg.h"
#include        "vs.h"
#include        "force.h"
#define         LOOP 10
extern errno;

main()
{
    struct intreg *mm;
    volatile caddr_t vme_addr;
    union vs *vs;
    union channel8data ch8;
    union bufw bufw;
    union bufr bufr;
    long *mm_long;
    int i, j;
    
/* Interrupt Register : A16D16 */
    vme_addr = (volatile caddr_t)vme_mapopen(VME_A16D16MODE, INTREG_ADDR,
                                             INTREG_SIZE);
    printf("map Interrupt Register A16 space : %x\n", vme_addr);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("intreg cannot open! \n");
        exit(1);
    }
    mm = (volatile struct intreg *)vme_addr;
    printf("address = %x\n", mm);

    if( vme_mapclose((caddr_t)vme_addr, VME_A16D16MODE) )
      printf("vme_mapclose : error no = %d\n", errno);
    printf("Unmap Interrupt Register A16 space\n");

    vme_addr = (volatile caddr_t)vme_mapopen(VME_A16D16MODE, INTREG_ADDR,
                                             INTREG_SIZE);
    printf("map Interrupt Register A16 space : %x\n", vme_addr);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("intreg cannot open! \n");
        exit(1);
    }
    mm = (volatile struct intreg *)vme_addr;
    printf("address = %x\n", mm);
    
    /* display contents of registers... */
    printf("Latch 0 = %4X\n",mm->latch[0] & 0xFF);
    printf("Latch 1 = %4X\n",mm->latch[1] & 0xFF);
    printf("in      = %4X\n",mm->in & 0xFF);
    printf("csr 0   = %4X\n",mm->csr[0] & 0xFF);
    printf("csr 1   = %4X\n",mm->csr[1] & 0xFF);

/* Visual Scaler : A24D16 */
    vme_addr = (volatile caddr_t)vme_mapopen(VME_A24D16MODE, VS_ADDR,
                                             VS_SIZE);
    printf("map Visual Scaler A24 space : %x\n", vme_addr);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("Visual Scaler cannot open! \n");
        exit(1);
      }

    vs = (volatile struct vs *)vme_addr;

    printf("address = %x\n", vs);

    for( i = 0; i < 8; i++) {
        ch8.data[0] = vs->ch8[i].data[0];
	ch8.data[1] = vs->ch8[i].data[1];
	printf("channel %d = %x (in hex)\n", i, ch8.ldata);
    }

/* Force Memory module : A32D32 */
    vme_addr = (volatile caddr_t)vme_mapopen(VME_A32D32MODE, MEM_A32D32,
                                             MEM_SIZE);
    printf("map Force Memory module A32 space : %x\n", vme_addr);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("intreg cannot open! \n");
        exit(1);
      }

    mm_long = (volatile long *)vme_addr;

    for( i = 0; i<LOOP; i++)
        for( j = 0; j< MEM_SIZE_LONG; j++)
            mm_long[j] = (volatile long)bufw.l[j];

 }









