/* File name : mp_test2.c
 * Creation date : November 1994
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

#include <stdio.h>
#include <sys/types.h>
#include "vmelib.h"
#include "mp.h"

main(argc,argv) int argc; char **argv; {
  int test_loop;
  int error_count;
  int ref;
  int i;

  volatile unsigned short *cmr;
  volatile caddr_t vme_addr;


  if (argc>1) ref = atoi(argv[1]);
  else        ref = 0;
  ref &= 0x1F;

  if (argc>2) test_loop = atoi(argv[2]);
  else        test_loop = 1000;
  
  
  vme_addr = (volatile caddr_t)vme_mapopen(VME_A32D32MODE, MP_ADDR,MP_SIZE);
  if (vme_addr == (volatile caddr_t)-1) {
    printf("mp cannot open! \n");
    exit(1);
  }

  cmr = (volatile unsigned short *)((int)vme_addr+0x7E000);

  error_count = 0;
  for(i=0;i<test_loop;i++) {

    *cmr = ref;
    if (((*cmr) & 0x01F) != ref) error_count++;
  }

  printf("Error %8d / %8d = %f%%\n",
	 error_count,test_loop,(float)(100*error_count)/(float)test_loop);

  if (vme_mapclose(vme_addr,VME_A32D32MODE) != 0) {
    printf("mp mapclose error! \n");
    exit(1);
  }
}









