/* File name     : vs_test.c
 * Creation date : August 1994
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Description   : The program tests the functions of VME Visual Scaler
 *                 produced by KEK.
 * Modified date : November 1994, Y.Yasu
 */

#include <stdio.h>
#include<sys/types.h>
#include "vmelib.h"
#include "vs.h"

union vs vsdata;
volatile union vs *vs;
union channel8data ch8;
union channel4data ch4;
struct ramdata panel[9];
char strings[132];

#if defined(ULTRIX) || defined(DEC)
long swapword();
#endif

main(argc, argv)
int argc;
char **argv;
{
    int i, j, mode;
    u_short sdata;
    char yesno;
    volatile caddr_t vme_addr;

    vme_addr = (volatile caddr_t)vme_mapopen(VME_A24D16MODE, VS_ADDR,
                                             VS_SIZE);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("visual scaler cannot open! \n");
        exit(1);
    }
    vs = (volatile union vs *)vme_addr;

    printf("address = %x\n", vs);

    if( argc < 2 )
        mode = 1;
    if( argc == 2 )
        mode = atoi(argv[1]);
    if( mode == 1 ) {
        /* 8 channel */
        printf("channel 8 mode ...\n");
	for( i = 0; i < 8; i++) {
	    ch8.data[0] = vs->ch8[i].data[0];
	    ch8.data[1] = vs->ch8[i].data[1];
#if defined(ULTRIX) || defined(DEC)
	    swapword( &ch8.data[0], &ch8.data[1]);
	    swapbyte( &ch8.data[0] );
	    swapbyte( &ch8.data[1] );
#endif
	    printf("channel %d = %x (in hex)\n", i, ch8.ldata);
	}
    } else if( mode == 2 ) {
        /* 4 channel */
        printf("channel 4 mode ...\n");
	for( i = 0; i < 4; i++) {
	    ch4.data[0] = vs->ch4[i].data[0];
	    ch4.data[1] = vs->ch4[i].data[1];
	    ch4.data[2] = vs->ch4[i].data[2];
	    ch4.data[3] = vs->ch4[i].data[3];
#if defined(ULTRIX) || defined(DEC)
	    swapword( &ch4.data[0], &ch4.data[3]);
	    swapword( &ch4.data[1], &ch4.data[2]);
#endif
	    printf("channel %1d upper = %x (in hex)\n", i, ch4.ldata.upper);
	    printf("          lower = %x (in hex)\n", ch4.ldata.lower);
	}
    } else if( mode == 3 ) {
        /* ram input mode */
        printf("ram input mode...\n");
	yesno = 'n';
	while ( yesno != 'y' ) {
	    printf("enter tittle : ");
	    scanf("%s", strings);
	    if( strlen(strings) >= VS_MAX_STRING )
	        strings[VS_MAX_STRING] = 0;
	    strcpy(panel[0].string, strings);
	    for( i = 0; i < 8; i++) {
	        printf("enter column #%1d : ", i);
		scanf("%s", strings);
		if( strlen(strings) >= VS_MAX_STRING )
		    strings[VS_MAX_STRING] = 0;
		strcpy(panel[i+1].string, strings);
	    }
	    printf("tittle    : %s\n", panel[0].string);
	    for( i = 0; i < 8; i++)
	        printf("column #%1d : %s\n", i, panel[i+1].string);
	    printf("are you sure?(y/n) "); scanf("%s", yesno);
        }
	/* write tittle */
	fillspace(panel[0].string);
	for(j = 0; j < VS_MAX_STRING; j++)
	    vs->ramdata[0].string[j] = panel[0].string[j];
	/* write columns */
	for(i = 1; i < VS_COLUMN; i++)
	    for( j = 0; j < VS_MAX_STRING; j++) {
	        fillspace(panel[i].string);
		vs->ramdata[i].string[j] = panel[i].string[j];
	    }
    }
}

fillspace(string)
char *string; {
    int i, len;

    len = strlen(string);
    for(i=len;i < VS_MAX_STRING; i++)
        string[i] = ' ';
    string[i] = 0;
}
