/* File name     : vs_write.c
 * Creation date : August 1994
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Description   : The program tests the functions of VME Visual Scaler
 *                 produced by KEK. The program can write data into
 *                 the scaler.
 */

#include <stdio.h>
#include<sys/types.h>
#include "vmelib.h"
#include "vs.h"

volatile union vs *vs;

main(argc, argv)
int argc;
char **argv;
{
    int i, j, mode;
    char yesno;
    u_short sdata;
    volatile caddr_t vme_addr;
    struct panel {
        char string[VS_MAX_STRING+1]; } panel[9];
    char strings[132];

    vme_addr = (volatile caddr_t)vme_mapopen(VME_A16D16MODE, VS_ADDR,
                                             VS_SIZE);
    if (vme_addr == (volatile caddr_t)-1 ) {
        printf("visual scaler cannot open! \n");
        exit(1);
    }
    vs = (volatile union vs *)vme_addr;
    printf("address = %x\n", vs);

    /* ram input mode */
    printf("ram input mode...\n");
    yesno = 'n';
    while ( yesno != 'y' ) {
        printf("enter tittle : ");
	scanf("%s", strings);
	if( strlen(strings) >= VS_MAX_STRING )
	    strings[VS_MAX_STRING] = 0;
	strcpy(panel[0].string, strings);
	for( i = 0; i < 8; i++) {
	    printf("enter column #%1d : ", i);
	    scanf("%s", strings);
	    if( strlen(strings) >= VS_MAX_STRING )
	        strings[VS_MAX_STRING] = 0;
	    strcpy(panel[i+1].string, strings);
	}
	printf("tittle    : %s\n", panel[0].string);
	for( i = 0; i < 8; i++)
	    printf("column #%1d : %s\n", i, panel[i+1].string);
	printf("are you sure?(y/n) "); scanf("%s", &yesno);
    }
    /* write tittle */
    fillspace(panel[0].string);
    for(i = 0; i < VS_COLUMN; i++)
        swapbytes(panel[i].string, VS_MAX_STRING);
    for(j = 0; j < VS_MAX_STRING; j++)
        vs->ramdata[0].string[j] = panel[0].string[j];
    /* write columns */
    for(i = 1; i < VS_COLUMN; i++)
        for( j = 0; j < VS_MAX_STRING; j++) {
	    fillspace(panel[i].string);
	    vs->ramdata[i].string[j] = panel[i].string[j];
	}
}

fillspace(string)
char *string; {
    int i, len;

    len = strlen(string);
    for(i=len;i < VS_MAX_STRING; i++)
        string[i] = ' ';
    string[i] = 0;
}

swapbytes(strings,len)
char *strings;
int len; {
    int i;
    char c;

    for(i = 0; i < len; i+=2 ) {
        c = strings[i];
	strings[i] = strings[i+1];
	strings[i+1] = c;
    }

}


