#define NINT 1   /* was in /sys/sun4m/GENERIC.int/int.h  */

struct intcmd {
  int number;
  int data;
  int reply1;
  int reply2;
};

#define VME_A16D16MODE 1
#define VME_A16D32MODE 2
#define VME_A24D16MODE 3
#define VME_A32D32MODE 4
#define VME_A32D16MODE 5
#define VME_A24D32MODE 6


#define MA_notINSTALL 40   /* for int_vector. 40 cannot be used for vector */
#define MA_INTERRUPT  50   /* for int_flag */
#define MA_WAITING    51
#define MA_TIMEOUT    52
#define MA_SIGNAL_STOP 53
#define MA_INTENABLE  60   /* for int_enable */
#define MA_INTDISABLE 61


#define INT_MIN_VECTOR 0xf0
#define INT_MAX_VECTOR 0xf9
#define NUMBER_OF_VECTOR (INT_MAX_VECTOR - INT_MIN_VECTOR + 1)

#define INT_INTR0 0         /* is vector 0xf0 */
#define INT_INTR1 1
#define INT_INTR2 2
#define INT_INTR3 3
#define INT_INTR4 4
#define INT_INTR5 5
#define INT_INTR6 6
#define INT_INTR7 7
#define INT_INTR8 8
#define INT_INTR9 9         /* is vector 0xf9 */


#define INT_default_TIMEOUT 10 /* unit second */


#define  INT_INIT    _IOWR(i,101,struct intcmd)
#define  INT_OPEN    _IOWR(i,102,struct intcmd)
#define  INT_CLOSE   _IOWR(i,103,struct intcmd)
#define  INT_ENABLE  _IOWR(i,104,struct intcmd)
#define  INT_DISABLE _IOWR(i,105,struct intcmd)
#define  INT_WAIT    _IOWR(i,106,struct intcmd)
#define  INT_NOWAIT  _IOWR(i,107,struct intcmd)
#define  INT_CLEAR   _IOWR(i,108,struct intcmd)
#define  INT_CHECK   _IOWR(i,109,struct intcmd)


/*********DON"T MIND BELOW LINES for user***************/
#define INTPRI (PZERO+1)
#define INTUNIT(dev) (minor(dev))
/*struct buf intbufs[NINT];               I can't understand here */
extern struct mb_hd mb_hd;      /*add by matono 4/27  */

struct int_device {
  char soft_csr;
  struct buf *int_bp;
  int int_count;
  char *int_cp;
  char int_busy;
} intdevice[NINT];





